//define the variables
var pairCards; //the number of pairs

//predefined from matchpair.css file
var gameStartPage = $("#gameStart");
var gameCards= $("#cards"); // cards which are on the screen
var uiPlay = $("#gamePlay"); // play mode of the game
var uiStats = $("#gameStats");
var gameComplete = $("#gameComplete");

//create array for putting 6 pairs of cards
var matchingGame = {};
matchingGame.deck = ['leipa', 'leipa', 'olut', 'olut', 'bussi', 'bussi', 'appelsiini', 'appelsiini', 'makkara', 'makkara', 'omena', 'omena'];

//defining the initiate function
$(function(){
	  init();
});

//setting game defaults
function init() {
					gameComplete.hide(); // gameover page is hidden
					gameCards.hide(); // all cards are hidden
					playGame = false;
					uiPlay.click(function(e) { // when "play" button is clicked StartPage is hidden
						e.preventDefault();
						gameStartPage.hide();
						startGame();
					});		
				
			}


//start game and create cards from deck array
function startGame(){
				
                //show cards and game screen
				uiStats.show();
				gameCards.show();

                //there are no pairs at the begining
				pairCards = 0;
			   	if (playGame == false) {
			   	    playGame = true;
                        //for all 12 cards, shuffle the deck
						matchingGame.deck.sort(shuffleCards);
						for(var i=0;i<11;i++){
								$(".card:first-child").clone().appendTo("#cards");
							}
						     	// initialize where each card is positioned
					        	gameCards.children().each(function (index) {
								// create correct position for 12 cards on the screen
								$(this).css({
									"left" : (40+$(this).width() + 70) * (index % 4),
									"top" : ($(this).height() + 20) * Math.floor(index / 4)
								});

								//get the from the shuffled deck
								var pattern = matchingGame.deck.pop();

					            //apply the pattern on the card's back side.
					       	    //put the pattern data into the DOM element.
					       	    // listen the click event for each card on the screen
								$(this).find(".back").addClass(pattern);	
								$(this).attr("data-pattern",pattern);				
								$(this).click(selectCard);
							});											 
				};			   
			  }


//randomly shuffle the cards for different positions
function shuffleCards() {
	return 0.5 - Math.random();
}

//function to see if cards are the same or not
function selectCard() {
	//return if there are already two cards flipped.
	if ($(".card-flipped").size() > 1) {
	return;
	}
	$(this).addClass("card-flipped");
	// check the pattern of flipped card in 0.6 of second.
	if ($(".card-flipped").size() == 2) {
	setTimeout(checkPattern,600);
	}
}

//function for checking if the card pattern are the same or not
function checkPattern() {
	if (isMatchPattern()) { //if cards are pairs 
		$(".card-flipped").removeClass("card-flipped").addClass("card-removed");
			if(document.webkitTransitionEnd){
				$(".card-removed").bind("webkitTransitionEnd",	removeTookCards);
			}else{
				removeTookCards();
			}
		} else {
		$(".card-flipped").removeClass("card-flipped");
	}
}

//put two flipped cards in an array to check if they have the same image.
function isMatchPattern() {
	var cards = $(".card-flipped");
	var card1 = $(cards[0]).data("pattern");
	var card2 = $(cards[1]).data("pattern");
	return (card1 == card2);
}

//check if all pairs are selected to end the game and hide all cards and show endgame page
function removeTookCards() {
    if (pairCards < 5) {
        pairCards++;
		$(".card-removed").remove();
	}else{
		$(".card-removed").remove();
		gameCards.hide();
		gameComplete.show();

	}	
}

